import cheerio from "cheerio";
import { isTypeReferenceNode } from "typescript";

export namespace Template {
    export async function check(html: string) {
        try {
            const $ = cheerio.load(html);

            return false;
        } catch (error) {
            console.error(`Error occured during stock check!`);
            return false;
        }
    }
}


export namespace FitnessKoerier {
    export async function check(html: string) {
        try {
            const $ = cheerio.load(html);
            if ($('.product-list .stock-msg').find("[itemprop=availability]").attr("content") == "out_of_stock") {
                return false;
            } else {
                return true;
            }
        } catch (error) {
            console.log(error);
            console.error(`Error occured during stock check!`);
            return false;
        }
    }
}


export namespace FitnessApparaat {
    export async function check(html: string) {
        try {
            const $ = cheerio.load(html);
            if ($('[itemprop="offers"]').find(".stock-red").length >= 1) {
                return false;
            } else {
                return true;
            }
        } catch (error) {
            console.log(error);
            console.error(`Error occured during stock check!`);
            return false;
        }
    }
}

export namespace BolCom {
    export async function check(html: string) {
        try {
            const $ = cheerio.load(html);
            if ($('[data-test="outofstock-buy-block"]').length >= 1) {
                return false;
            } else {
                return true;
            }
        } catch (error) {
            console.log(error);
            console.error(`Error occured during stock check!`);
            return false;
        }
    }
}

export namespace BeterSport {
    export async function check(html: string) {
        try {
            const $ = cheerio.load(html);
            if ($('.product-shop .in-stock').first().html() !== null) {
                if ($('.product-shop .in-stock').first().html().trim() == "Niet op voorraad, neem contact op voor actuele informatie") {
                    return false;
                }
                
                else if ($('.product-shop .in-stock').first().html().trim().includes("week")) {
                    return false;
                }
                
                else {
                    return true;
                }
            } else {
                return true;
            }
        } catch (error) {
            console.log(error);
            console.error(`Error occured during stock check!`);
            return false;
        }
    }
}

export namespace FitnessGeest {
    export async function check(html: string) {
        try {
            const $ = cheerio.load(html);
            if ($('.product-info-box .in_stock_message').length >= 1) {
                return true;
            } else {
                return false;
            }
        } catch (error) {
            console.log(error);
            console.error(`Error occured during stock check!`);
            return false;
        }
    }
}

export namespace BodyAndFit {
    export async function check(html: string) {
        try {
            const $ = cheerio.load(html);
            if ($('.product-page .product-cart-controls .btn__primary').first().attr("disabled")) {
                return false;
            } else {
                return true;
            }
        } catch (error) {
            console.log(error);
            console.error(`Error occured during stock check!`);
            return false;
        }
    }
}